<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout align-center justify-center>
        <v-card max-width="90%">
            <v-card-title>
                <v-layout column>

                    <v-btn
                            color="green"
                            dark
                            small
                            absolute
                            top
                            left
                            fab
                            @click="add"
                    >
                        <v-icon light>add</v-icon>
                    </v-btn>
                    <v-data-table
                            :headers="headers"
                            :items="allData"
                            hide-actions
                    >
                        <template
                                slot="headerCell"
                                slot-scope="{ header }"
                        >
                    <span class="subheading font-weight-light text-success text--darken-3"
                          v-text="header.text"
                    ></span>

                        </template>
                        <template v-slot:no-data>
                            <div v-show="allDataLoading === true" class="justify-center layout px-0">
                                <v-progress-circular indeterminate color="primary"
                                                     align-center justify-center row></v-progress-circular>
                            </div>

                            <div v-show="allData.length === 0 && allDataLoading === false"
                                 class="justify-center layout px-0">
                                {{'داده ای وجود ندارد'}}
                            </div>

                        </template>
                        <template
                                slot="items"
                                slot-scope="{ item }"
                        >
                            <td>{{ item.name}}</td>
                            <td>{{ item.cargo_owners_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.drivers_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.carriers_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.marketers_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.messages_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.vehicle_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.cargo_type_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.discount_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.setting_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.order_report_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.transaction_report_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.dashboard_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.advertising_box_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.static_content_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.role_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.operator_permission === 0 ? 'ندارد' : 'دارد'}}</td>
                            <td>{{ item.regulation_permission === 0 ? 'ندارد' : 'دارد'}}</td>

                            <td class="justify-center layout px-0">
                                <v-icon
                                        small
                                        class="mr-2"
                                        @click="edit(item)"
                                >
                                    edit
                                </v-icon>

                                <v-icon
                                        small
                                        @click="deleteItem(item)"
                                >
                                    delete
                                </v-icon>
                            </td>
                        </template>
                    </v-data-table>
                </v-layout>
            </v-card-title>
        </v-card>
        <v-dialog v-model="AddDialog" persistent max-width="800px" max-height="700px">
            <v-card>
                <v-card-text>
                    <v-container grid-list-md>
                        <v-layout wrap>
                            <v-flex xs12 md4 sm4>
                                <v-text-field @change="setName" v-model="selectedItem.name" label="اسم"></v-text-field>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setCargoOwnersPermission" v-model="selectedItem.cargo_owners_permission" label="صاحبان بار"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setDriversPermission" v-model="selectedItem.drivers_permission" label="رانندگان"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setCarriersPermission" v-model="selectedItem.carriers_permission" label="باربری ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setMarketersPermission" v-model="selectedItem.marketers_permission" label="بازاریابان"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setMessagesPermission" v-model="selectedItem.messages_permission" label="پیام ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setVehiclePermission" v-model="selectedItem.vehicle_permission" label="ماشین ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setCargoTypePermission" v-model="selectedItem.cargo_type_permission" label="بار ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setDiscountPermission" v-model="selectedItem.discount_permission" label="تخفیف ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setSettingPermission" v-model="selectedItem.setting_permission" label="تنظیمات"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setOrderReportPermission" v-model="selectedItem.order_report_permission" label="گزارشات"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setTransactionReportPermission" v-model="selectedItem.transaction_report_permission" label="تراکنش ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setDashboardPermission" v-model="selectedItem.dashboard_permission" label="داشبورد"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setAdvertisingBoxPermission" v-model="selectedItem.advertising_box_permission" label="تبلیغات"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setStaticContentPermission" v-model="selectedItem.static_content_permission" label="محتوا"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setRolePermission" v-model="selectedItem.role_permission" label="نقش ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setOperatorPermission" v-model="selectedItem.operator_permission" label="اپراتور ها"></v-checkbox>
                            </v-flex>
                            <v-flex xs12 md4 sm4>
                                <v-checkbox @change="setRegulationPermission" v-model="selectedItem.regulation_permission" label="قوانین"></v-checkbox>
                            </v-flex>
                        </v-layout>
                    </v-container>
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideAddDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="add_Edit">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">ذخیره</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
                v-model="DeleteDialog"
                width="500"
        >

            <v-card>
                <v-card-text>
                    آیا مطمئن هستید که می خواهید این نقش را حذف کنید؟
                </v-card-text>

                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="hideDeleteDialog">لغو</v-btn>
                    <v-btn color="blue darken-1" flat @click="deleteOne">
                        <v-progress-circular v-show="this.pending === true" indeterminate
                                             color="white"></v-progress-circular>
                        <div v-show="this.pending === false">حذف</div>
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "role",
        methods: {
            ...mapMutations({
                setName: 'role/setName',
                setCargoOwnersPermission: 'role/setCargoOwnersPermission',
                setDriversPermission: 'role/setDriversPermission',
                setCarriersPermission: 'role/setCarriersPermission',
                setMarketersPermission: 'role/setMarketersPermission',
                setMessagesPermission: 'role/setMessagesPermission',
                setVehiclePermission: 'role/setVehiclePermission',
                setCargoTypePermission: 'role/setCargoTypePermission',
                setDiscountPermission: 'role/setDiscountPermission',
                setSettingPermission: 'role/setSettingPermission',
                setOrderReportPermission: 'role/setOrderReportPermission',
                setTransactionReportPermission: 'role/setTransactionReportPermission',
                setDashboardPermission: 'role/setDashboardPermission',
                setAdvertisingBoxPermission: 'role/setAdvertisingBoxPermission',
                setStaticContentPermission: 'role/setStaticContentPermission',
                setRolePermission: 'role/setRolePermission',
                setOperatorPermission: 'role/setOperatorPermission',
                setRegulationPermission: 'role/setRegulationPermission',
                setSelectedItem: 'role/setSelectedItem',
                showAddDialog: 'role/showAddDialog',
                hideAddDialog: 'role/hideAddDialog',
                showDeleteDialog: 'role/showDeleteDialog',
                hideDeleteDialog: 'role/hideDeleteDialog'
            }),
            ...mapActions({
                readData: 'role/readData',
                addOrEdit: 'role/addOrEdit',
                deleteOne: 'role/deleteOne'
            }),

            add() {
                this.setSelectedItem({
                    id: null,
                    name: null,
                    cargo_owners_permission: 0,
                    drivers_permission: 0,
                    carriers_permission: 0,
                    marketers_permission: 0,
                    messages_permission: 0,
                    vehicle_permission: 0,
                    cargo_type_permission: 0,
                    discount_permission: 0,
                    setting_permission: 0,
                    order_report_permission: 0,
                    transaction_report_permission: 0,
                    dashboard_permission: 0,
                    advertising_box_permission: 0,
                    static_content_permission: 0,
                    role_permission: 0,
                    operator_permission: 0,
                    regulation_permission: 0,
                });
                this.showAddDialog();
            },
            edit(item) {
                this.setSelectedItem({
                    id: item.id,
                    name: item.name,
                    cargo_owners_permission: item.cargo_owners_permission,
                    drivers_permission: item.drivers_permission,
                    carriers_permission: item.carriers_permission,
                    marketers_permission: item.marketers_permission,
                    messages_permission: item.messages_permission,
                    vehicle_permission: item.vehicle_permission,
                    cargo_type_permission: item.cargo_type_permission,
                    discount_permission: item.discount_permission,
                    setting_permission: item.setting_permission,
                    order_report_permission: item.order_report_permission,
                    transaction_report_permission: item.transaction_report_permission,
                    dashboard_permission: item.dashboard_permission,
                    advertising_box_permission: item.advertising_box_permission,
                    static_content_permission: item.static_content_permission,
                    role_permission: item.role_permission,
                    operator_permission: item.operator_permission,
                    regulation_permission: item.regulation_permission,
                });
                this.showAddDialog();
            },
            add_Edit() {
                this.addOrEdit();
            },

            deleteItem(item) {
                this.setSelectedItem(item);
                this.showDeleteDialog()
            },
        },
        computed: {
            ...mapState({
                allData: state => state.role.allData,
                allVehicleGroups: state => state.role.allVehicleGroups,
                AddDialog: state => state.role.AddDialog,
                DeleteDialog: state => state.role.DeleteDialog,
                selectedItem: state => state.role.selectedItem,
                pending: state => state.role.pending,
                allDataLoading: state => state.role.allDataLoading,
            })
        },
        mounted() {
            this.readData();
        },
        data() {
            return {
                headers: [
                    {text: 'نام', align: 'right', value: 'name'},
                    {text: 'صاحب بار', align: 'right', value: 'cargo_owners_permission'},
                    {text: 'رانندگان', align: 'right', value: 'drivers_permission'},
                    {text: 'باربری ها', align: 'right', value: 'carriers_permission'},
                    {text: 'بازاریابان', align: 'right', value: 'marketers_permission'},
                    {text: 'پیام ها', align: 'right', value: 'messages_permission'},
                    {text: 'ماشین ها', align: 'right', value: 'vehicle_permission'},
                    {text: 'بار ها', align: 'right', value: 'cargo_type_permission'},
                    {text: 'تخفیف ها', align: 'right', value: 'discount_permission'},
                    {text: 'تنظیمات', align: 'right', value: 'setting_permission'},
                    {text: 'گزارشات', align: 'right', value: 'order_report_permission'},
                    {text: 'تراکنش ها', align: 'right', value: 'transaction_report_permission'},
                    {text: 'داشبورد', align: 'right', value: 'dashboard_permission'},
                    {text: 'تبلیغات', align: 'right', value: 'advertising_box_permission'},
                    {text: 'محتوا', align: 'right', value: 'static_content_permission'},
                    {text: 'نقش ها', align: 'right', value: 'role_permission'},
                    {text: 'اپراتور', align: 'right', value: 'operator_permission'},
                    {text: 'قوانین', align: 'right', value: 'regulation_permission'},
                ],
            }
        },

    }
</script>
<style scoped>
</style>